
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

/* 
 * sickType.h:     La SDI_F de sick
 *
 * Utilise par le module et par les clients
 * (inclut dans sickMsgLib.h et sickPosterLib.h)
 * 
 */

#ifndef sick_TYPE_H
#define sick_TYPE_H

#include "genom/modules.h"
#include "sickError.h"

/* Nombre de tache d'execution de ce module */
#define SICK_NB_EXEC_TASK                   (1)


#endif
#ifndef sick_TYPE1_H
#define sick_TYPE1_H

#include "/opt/openrobots/include/genBasic/genBasicStruct.h"
#include "/opt/openrobots/include/pom/pomStruct.h"
#include "sickStruct.h"

/*
 * Structure de donnees interne
 */
typedef struct SICK_STR {
	SICK_INIT_PARAMS initParams;
	POM_EULER sickPosOnRobot;
	SICK_PARSER_CONTROL_STR parser;
	SICK_CONTROL_MODES control_mode;
	SICK_SCAN_MODES scan_mode;
	SICK_CONTROL_MODES required_control_mode;
	SICK_SCAN_TASK_STATE state;
	SICK_USER_STR user_config;
	SICK_CONFIG_STR sick_config;
	SICK_POLAR_MEASURES_STR polarMeasures;
	SICK_CART_MEASURES_STR cartMeasures;
	SICK_SAVE_FILE_PARAMS saveFileParams;
	SICK_SEG_PARAMS segParams;
	SICK_BOOL readSickFile;
	SICK_BOOL readEnvFile;
	int synchroPosTunning;
	GEN_STRING256 envFileName;
	SICK_BOOL externLocFlag;
	GEN_STRING128 logFileName;
} SICK_STR;


#endif

