
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef sick_TCLSERV_CLIENT_ERROR_H
#define sick_TCLSERV_CLIENT_ERROR_H

#include <server/sickError.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum sick_error {
	E_sick_OK					  			= 0,

	/* module errors */
	E_sick_FILE_NOT_FOUND                 = S_sick_FILE_NOT_FOUND,
	E_sick_BAD_PARAMS                     = S_sick_BAD_PARAMS,
	E_sick_CANNOT_WRITE_FILE              = S_sick_CANNOT_WRITE_FILE,
	E_sick_CANNOT_OPEN_FILE               = S_sick_CANNOT_OPEN_FILE,
	E_sick_isnot_initialized              = S_sick_isnot_initialized,
	E_sick_reset_error                    = S_sick_reset_error,
	E_sick_serial_output_error            = S_sick_serial_output_error,
	E_sick_serial_input_error             = S_sick_serial_input_error,
	E_sick_cannot_connect_to_pom          = S_sick_cannot_connect_to_pom,
	E_sick_bad_tram                       = S_sick_bad_tram,
	E_sick_cannot_find_baud_rate          = S_sick_cannot_find_baud_rate,
	E_sick_time_out                       = S_sick_time_out,
	E_sick_fatal_error                    = S_sick_fatal_error,


	/* std errors */
	E_sick_ACTIVITY_INTERRUPTED           = S_sick_stdGenoM_ACTIVITY_INTERRUPTED,
	E_sick_TOO_MANY_ACTIVITIES            = S_sick_stdGenoM_TOO_MANY_ACTIVITIES,
	E_sick_ACTIVITY_FAILED                = S_sick_stdGenoM_ACTIVITY_FAILED,
	E_sick_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_sick_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_sick_UNKNOWN_ACTIVITY               = S_sick_stdGenoM_UNKNOWN_ACTIVITY,
	E_sick_FORBIDDEN_ACTIVITY_TRANSITION  = S_sick_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_sick_SYSTEM_ERROR                   = S_sick_stdGenoM_SYSTEM_ERROR,
	E_sick_ACTIVITY_ALREADY_ENDED         = S_sick_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_sick_WAIT_INIT_RQST                 = S_sick_stdGenoM_WAIT_INIT_RQST,
	E_sick_CONTROL_CODEL_ERROR            = S_sick_stdGenoM_CONTROL_CODEL_ERROR,
	E_sick_EXEC_TASK_SUSPENDED            = S_sick_stdGenoM_EXEC_TASK_SUSPENDED,
	E_sick_BAD_BLOCK_TYPE                 = S_sick_stdGenoM_BAD_BLOCK_TYPE,
	E_sick_BAD_POSTER_TYPE                = S_sick_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum sick_error sick_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int sick_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the sick context.
 *
 * Returns NULL in case of failure
 */
const char* sick_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
